{*******************************************************}
{       GranPrimo Component Library                     }
{       Debug and control application via web           }
{                                                       }
{       Copyright (c) 2001-2003 Antonio Alczar Ruiz    }
{*******************************************************}

unit mainmininet;
{$i incspynet}

interface

uses Windows,messages, Controls, StdCtrls, Graphics,
        ComCtrls, Classes,forms,SysUtils,
        ExtCtrls, misocknet, spykernet,gptray,
        Buttons,gpobjects,gpmiportal ;

 type
 TAcercaDelGran = class(TForm)
    PControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    L3: TLabel;
    PortEdi: TEdit;
    L2: TLabel;
    EdHtmlMai: TEdit;
    ListenButton: TButton;
    StopButton: TButton;
    B1: TButton;
    Edpas: TEdit;
    L5: TLabel;
    Image: TImage;
    l1: TLabel;
    l11: TLabel;
    Timer1: TTimer;
    test: TButton;
    Label2: TLabel;
    ezoom: TEdit;
    StaticText1: TStaticText;
    Edmaxlines: TEdit;
    B3: TButton;
    Trace: TCheckBox;
    Checkproxy: TCheckBox;
    Me: TMemo;
    Edremoto: TEdit;
    edportremoto: TEdit;
    emagic: TEdit;
    Remoto: TButton;
    procedure ListenButtonClick(Sender: TObject);
    procedure B1Click(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure B3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RemotoClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure testClick(Sender: TObject);
    procedure granprimoeco(const datos: String);
  private
    granprimo:tMiPortal;
    proxy : TSpyceProxy;
    procedure Atender;
    procedure Status;
    procedure Error(Sender: TObject; E: Exception);
    procedure WMtray(var Message: TMessage); message CMTRAYICON;
    procedure Muestra;
  end;


implementation

uses Shellapi,convierte;

{$R *.DFM}

procedure TAcercaDelGran.Atender;
begin
    if Checkproxy.Checked then
        granprimo.service:=ServeBridge
        else
        granprimo.service:=ServeGranprimo;
    granprimo.sock.Active:=false;
    granprimo.inspector.spyObject:=self; 
//    granprimo.menu.rehelp:=khline;
    granprimo.screen_.zoom:=strtoint(ezoom.Text);
    granprimo.passwords.home :=EdHtmlMai.text;
    granprimo.passwords.passwordAdmin:=Edpas.Text;
    granprimo.sock.Port        := strtoint(PortEdi.Text);
    granprimo.sock.Active:=true;
    Status;
end;


procedure TAcercaDelGran.ListenButtonClick(Sender: TObject);
begin
      atender;
end;


procedure TAcercaDelGran.B1Click(Sender: TObject);
begin
 granprimo.TrayIcon.TrayActive:=true;
 if granprimo.TrayIcon.TrayActive then
  hide;
end;


procedure TAcercaDelGran.StopButtonClick(Sender: TObject);
begin
    granprimo.sock.active:=false;
    Status
end;


procedure TAcercaDelGran.Status;
var a:boolean;
begin
    a:=granprimo.sock.active;
    Checkproxy.enabled:=not a;
    EdHtmlMai.enabled:= not a;
    Edpas.enabled:= not a;
    PortEdi.Enabled       := not a;
    ListenButton.Enabled    := not a;
    StopButton.Enabled     := a;
end;


procedure TAcercaDelGran.FormActivate(Sender: TObject);
begin
  Application.OnException:=error;
end;

procedure TAcercaDelGran.Error(Sender: TObject; E: Exception);
begin
end;

procedure TAcercaDelGran.FormCreate(Sender: TObject);
begin
 granprimo:=TmiPortal.Create(self);
 // to active a safe (thread sinchronized) log trace
 granprimo.oneco:= granprimoeco;
 Image.Picture.Bitmap.Handle :=LoadBitmap(HInstance, 'SPYLOGO');
 l1.caption:=L1.caption+' .ver:'+KGPVERSION;
 granprimo.trayIcon.NewTrayIcon (handle,LoadIcon( hInstance, 'MAINICONN' ));
// granprimo.spice.fform:=nil;
 granprimo.spice.doform(TFormConvert);
 proxy := TSpyceProxy(granprimo.MakeSpyce(TSpyceProxy));
// granprimo.sock.BoundIP:='127.0.0.1';
 // BoundIp is the Ip interface to active, if null then all Ips are allowed
 // with bound Ip 127.0.0.1, only you can access
end;


procedure TAcercaDelGran.B3Click(Sender: TObject);
begin
  me.clear;
end;


procedure TAcercaDelGran.FormClose(Sender: TObject;var Action: TCloseAction);
begin
   StopButtonClick(Sender);
   action:=cafree;
end;

procedure TAcercaDelGran.RemotoClick(Sender: TObject);
begin
   GranPrimo.sock.ConnectClient (Edremoto.Text,ValInt( edportremoto.text),
   ValInt( emagic.text))
end;

procedure TAcercaDelGran.Timer1Timer(Sender: TObject);
begin
     Timer1.Enabled:=false;
     if not granprimo.sock.Active then
        Atender
end;

procedure TAcercaDelGran.testClick(Sender: TObject);
begin
  if not granprimo.sock.active then
    Atender;
    runselfBrowser_(  granprimo.sock);
end;


procedure TAcercaDelGran.granprimoeco(const datos: String);
begin
   if not Trace.Checked then exit;
   if me.lines.Count>strtoint(Edmaxlines.Text) then
      me.clear;
   Me.Lines.Add(datos);
end;
procedure TAcercaDelGran.Muestra;
begin
   granprimo.TrayIcon.trayActive := False;
   visible:=true;
end;

procedure TAcercaDelGran.WMtray(var Message: TMessage);
begin
   Muestra
end;

end.

